# 	Copyright (c) 2005-2007 ALT Linux, Peter V. Saveliev
#
# 	This file is part of Connexion project.
#
# 	Connexion is free software; you can redistribute it and/or modify
# 	it under the terms of the GNU General Public License as published by
# 	the Free Software Foundation; either version 2 of the License, or
# 	(at your option) any later version.
#
# 	Connexion is distributed in the hope that it will be useful,
# 	but WITHOUT ANY WARRANTY; without even the implied warranty of
# 	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# 	GNU General Public License for more details.
#
# 	You should have received a copy of the GNU General Public License
# 	along with Connexion; if not, write to the Free Software
# 	Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

from cxutil import flags
from command import command, swrapper

class backup (command):
	'''
	Backup operations
	'''

	mask = flags.Begin | flags.Bypass

	modules = [
		"write",
		"restore",
		"resurrect",
	]

	class write (command):
		'''
		Write configuration to disk
		'''

		socket = "/var/run/connexion/socket"
		target = "/etc/connexion/config"

		def postUp(self,opts):
			result = swrapper()
			result.add_command(
				"system",
				"connexion-cli -bs %s -e tree > %s" % (self.socket,self.target)
			)
			return result

	class restore (command):
		'''
		Merge configuration from disk
		'''

		socket = "/var/run/connexion/socket"
		target = "/etc/connexion/config"

		def postUp(self,opts):
			result = swrapper()
			result.add_command(
				"system",
				"connexion-cli -abs %s -e 'merge;.source %s;commit'" % (self.socket,self.target)
			)
			return result

	class resurrect (command):
		'''
		Merge configuration from disk, but do not execute
		'''

		socket = "/var/run/connexion/socket"
		target = "/etc/connexion/config"

		def postUp(self,opts):
			result = swrapper()
			result.add_command(
				"system",
				"connexion-cli -abs %s -e 'merge;.source %s;commit noexec'" % (self.socket,self.target)
			)
			return result
