from command import command, swrapper
from cxutil import utils,flags,cmask

class l7 (command):
	"""
	l7 hidden class
	"""

	mask = flags.Satellite | flags.Hidden

	catch = ["l7"]

	def postUp(self,opts):
		if not opts.call_mask & cmask.Signal:
			return

		dev = opts.envl.signal
		q = opts.envg.l7base.index(dev) + 1

		###
		# check for iptables rules
		###
		result = swrapper()
		result.add_commands("exec",[
			"modprobe ip_conntrack_netlink",
			"iptables -t mangle -D OUTPUT -o %s -j NFQUEUE --queue-num %s" %  (dev,q),
			"iptables -t mangle -I OUTPUT -o %s -j NFQUEUE --queue-num %s" %  (dev,q),
			"iptables -t mangle -D FORWARD -o %s -j NFQUEUE --queue-num %s" % (dev,q),
			"iptables -t mangle -I FORWARD -o %s -j NFQUEUE --queue-num %s" % (dev,q),
		])
		###
		# create protocol set
		###
		ps = ""
		for i in opts.envg.l7[dev]:
			ps += " -P %s:%s" % (i, opts.envg.l7[dev].index(i) + q * 1024)
		###
		# check for running l7 and restart it with new protocol set
		###
		result.add_command("daemon",{
			"action": "check",
			"command": "l7-filter -q %s %s" % (q,ps),
			"id": "l7-filter",
			"condition": ps
		})
		return result
